# SQS

Kubemq aws-sqs target connector allows services using kubemq server to access aws sqs service.

## Prerequisites

The following required to run the aws-sqs target connector:

* kubemq cluster
* aws account with sqs active service
* kubemq-source deployment

## Configuration

sqs target connector configuration properties:

| Properties Key   | Required | Description                                                  | Example                        |
| ---------------- | -------- | ------------------------------------------------------------ | ------------------------------ |
| aws\_key         | yes      | aws key                                                      | aws key supplied by aws        |
| aws\_secret\_key | yes      | aws secret key                                               | aws secret key supplied by aws |
| region           | yes      | region                                                       | aws region                     |
| retries          | no       | number of retries on send                                    | 1 (default 0)                  |
| token            | no       | aws token ("default" empty string                            | "my token"                     |
| dead\_letter     | no       | dead letter queue name (only relevant to SetQueueAttributes) | "my\_dead\_letter\_queue"      |
| max\_receive     | no       | max receive of queue (only relevant to SetQueueAttributes)   | "0"                            |

Example:

```yaml
bindings:
  - name: kubemq-query-aws-sqs
    source:
      kind: kubemq.query
      name: kubemq-query
      properties:
        address: "kubemq-cluster:50000"
        client_id: "kubemq-query-aws-sqs-connector"
        auth_token: ""
        channel: "query.aws.sqs"
        group:   ""
        auto_reconnect: "true"
        reconnect_interval_seconds: "1"
        max_reconnects: "0"
    target:
      kind: aws.sqs
      name: aws-sqs
      properties:
        aws_key: "id"
        aws_secret_key: 'json'
        region:  "instance"
        token:  ""
        retries: "1"
```

## Usage

### Send Message

send message to sqs.

Send Message:

| Metadata Key | Required | Description                            | Possible values                    |
| ------------ | -------- | -------------------------------------- | ---------------------------------- |
| queue        | yes      | name of queue to send                  | "my\_queue"                        |
| delay        | yes      | message delay                          | "0"                                |
| tags         | no       | message tags (key value string string) | "{"tag-1":"test","tag-2":"test2"}" |
| data         | yes      | type of method                         | "dmFsaWQgYm9keQ=="                 |

Example:

```javascript
{
  "metadata": {
    "queue": "my_queue",
    "delay": "0",
    "tags": "{\"tag-1\":\"test\",\"tag-2\":\"test2\"}"
  },
  "data": "dmFsaWQgYm9keQ=="
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kubemq.io/configuration/connectors/kubemq-targets/aws/sqs.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
